/*
 * Copyright © 2021-2022 Fachhochschule für die Wirtschaft (FHDW) Hannover
 *
 * This file is part of ipspiel22-demo.
 *
 * Ipspiel22-demo is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the Free
 * Software Foundation, either version 3 of the License, or (at your option) any
 * later version.
 *
 * Ipspiel22-demo is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details.
 *
 * You should have received a copy of the GNU General Public License along with
 * ipspiel22-demo. If not, see <http://www.gnu.org/licenses/>.
 */
module de.fhdw.gaming.ipspiel22.gefangenenDilemma {
    exports de.fhdw.gaming.ipspiel22.gefangenenDilemma.domain;
    exports de.fhdw.gaming.ipspiel22.gefangenenDilemma.domain.factory;
    exports de.fhdw.gaming.ipspiel22.gefangenenDilemma.moves;
    exports de.fhdw.gaming.ipspiel22.gefangenenDilemma.moves.factory;

    requires transitive de.fhdw.gaming.core;

    uses de.fhdw.gaming.ipspiel22.gefangenenDilemma.domain.factory.GDStrategyFactory;

    provides de.fhdw.gaming.ipspiel22.gefangenenDilemma.domain.factory.GDStrategyFactory
            with de.fhdw.gaming.ipspiel22.gefangenenDilemma.strategy.GDQuietStrategyFactory,
            de.fhdw.gaming.ipspiel22.gefangenenDilemma.strategy.GDStatementStrategyFactory;

    provides de.fhdw.gaming.core.domain.GameBuilderFactory
            with de.fhdw.gaming.ipspiel22.gefangenenDilemma.domain.impl.GDGameBuilderFactoryImpl;

    opens de.fhdw.gaming.ipspiel22.gefangenenDilemma.domain;
    opens de.fhdw.gaming.ipspiel22.gefangenenDilemma.domain.factory;
    opens de.fhdw.gaming.ipspiel22.gefangenenDilemma.domain.impl;
    opens de.fhdw.gaming.ipspiel22.gefangenenDilemma.moves;
    opens de.fhdw.gaming.ipspiel22.gefangenenDilemma.strategy;
}
